;-================================================================;
;- Copyright (C) 2000 H-Peter Recktenwald, Berlin <phpr@snafu.de>
;- Read ./doc/LEGAL file for full copyright information (GNU GPL)
;-
;-  file	: ptrace.h.inc
;-  switch	: __RELOC_I
;-  created	: 17-jan-2001
;-  modified	:
;-  version	: 0.01
;-  assembler	: nasm 0.98-3e
;-  description	:
;-  author	: H-Peter Recktenwald, Berlin <phpr@snafu.de>
;-  comment	: unless stated all macroes case-sensitive
;-  source	: include/asm/ptrace.h
;-  requires	: scilab's patched nasm 0.98e
;-		:	ftp://ftp.linuxgames.com/crystal/nasm/
;-================================================================;
;-

%ifndef _I386_PTRACE_H
%define i386ptracehinc
%define _I386_PTRACE_H

; added prefix PT_ for the assmbler [hp'01]
%assign PT_EBX	 0
%assign PT_ECX	 1
%assign PT_EDX	 2
%assign PT_ESI	 3
%assign PT_EDI	 4
%assign PT_EBP	 5
%assign PT_EAX	 6
%assign PT_DS	 7
%assign PT_ES	 8
%assign PT_FS	 9
%assign PT_GS	10
%assign PT_ORIG_EAX 11
%assign PT_EIP	12
%assign PT_CS	13
%assign PT_EFL	14
%assign PT_UESP	15
%assign PT_SS	16


/* this struct defines the way the registers are stored on the 
   stack during a system call. */

    struc pt_regs
.ebx        	long 
.ecx        	long 
.edx        	long 
.esi        	long 
.edi        	long 
.ebp        	long 
.eax        	long 
.xds        	int  
.xes        	int  
.orig_eax   	long 
.eip        	long 
.xcs        	int  
.eflags     	long 
.esp        	long 
.xss		int  
    endstruc

/* Arbitrarily choose the same ptrace numbers as used by the Sparc code. */
%assign PTRACE_GETREGS            12
%assign PTRACE_SETREGS            13
%assign PTRACE_GETFPREGS          14
%assign PTRACE_SETFPREGS          15

;%ifdef __KERNEL__
; user_mode(regs) ((VM_MASK & (regs)->eflags) || (3 & (regs)->xcs))
%define user_mode(regs) ((VM_MASK & (regs+pt_regs.eflags) || (3 & (regs+pt_regs.xcs))
; instruction_pointer(regs) ((regs)->eip)
%define instruction_pointer(regs) (regs+pt_regs.eip)

;extern void show_regs(struct pt_regs *)
%macro show_regs 1
%ifidn %00
%00:
%endif
    pt_regs %{1}
%endm

;%endif;__KERNEL__

%endif;_I386_PTRACE_H
;-
;-
;-================================================================;
;- ptrace.h.inc <eof>
