;-=========================================================================;
;- Copyright (C) 2000 H-Peter Recktenwald, Berlin <phpr@snafu.de>
;- Read ./doc/LEGAL file for full copyright information (GNU GPL)
;-
;-  file  	: stat.h.inc
;-  switch	: _I386_STAT_H, stathinc, _LINUX_STAT_H, linuxstathinc
;-  created	: 25-Aug-2000
;-  modified	: 06-Mai-2001
;-  version	: 0.02
;-  assembler	: nasm 0.98-3e+
;-  description	: file/device status data & struc.
;-  author	: H-Peter Recktenwald, Berlin <lux@snafu.de>
;-  comment	: 
;-  source	: include/asm/stat.h, include/linux/stat.h
;-  requires	: "asmutils" by K.Boldyshev, http://linuxassembly.org
;-=========================================================================;
;-
;-
%ifndef _I386_STAT_H
%define _I386_STAT_H
%define stathinc

%ifnid __old_kernel_stat
 struc __old_kernel_stat
.st_dev:	SHORT 
.st_ino:	SHORT 
.st_mode:	SHORT 
.st_nlink:	SHORT 
.st_uid:	SHORT 
.st_gid:	SHORT 
.st_rdev:	SHORT 
.st_size:	LONG  
.st_atime:	LONG  
.st_mtime:	LONG  
.st_ctime:	LONG  
 endstruc
%endif

%ifnid stat
 struc stat
.st_dev:	SHORT
.__pad1:	SHORT
.st_ino:	LONG 
.st_mode:	SHORT
.st_nlink:	SHORT
.st_uid:	SHORT
.st_gid:	SHORT
.st_rdev:	SHORT
.__pad2:	SHORT
.st_size:	LONG 
.st_blksize:	LONG 
.st_blocks:	LONG 
.st_atime:	LONG 
.__unused1:	LONG 
.st_mtime:	LONG 
.__unused2:	LONG 
.st_ctime:	LONG 
.__unused3:	LONG 
.__unused4:	LONG 
.__unused5:	LONG 
 endstruc
%endif

%ifndef _LINUX_STAT_H
%define _LINUX_STAT_H
%define linuxstathinc

%define S_IFMT		0170000q
%define S_IFSOCK	0140000q
%define S_IFLNK		0120000q
%define S_IFREG		0100000q
%define S_IFBLK		0060000q
%define S_IFDIR		0040000q
%define S_IFCHR		0020000q
%define S_IFIFO		0010000q
%define S_ISUID		0004000q
%define S_ISGID		0002000q
%define S_ISVTX		0001000q

%define S_ISLNK(m)	(((m) & S_IFMT) == S_IFLNK)
%define S_ISREG(m)	(((m) & S_IFMT) == S_IFREG)
%define S_ISDIR(m)	(((m) & S_IFMT) == S_IFDIR)
%define S_ISCHR(m)	(((m) & S_IFMT) == S_IFCHR)
%define S_ISBLK(m)	(((m) & S_IFMT) == S_IFBLK)
%define S_ISFIFO(m)	(((m) & S_IFMT) == S_IFIFO)
%define S_ISSOCK(m)	(((m) & S_IFMT) == S_IFSOCK)

%define S_IRWXU		00700q
%define S_IRUSR		00400q
%define S_IWUSR		00200q
%define S_IXUSR		00100q

%define S_IRWXG		00070q
%define S_IRGRP		00040q
%define S_IWGRP		00020q
%define S_IXGRP		00010q

%define S_IRWXO		00007q
%define S_IROTH		00004q
%define S_IWOTH		00002q
%define S_IXOTH		00001q

%define S_IRWXUGO	(S_IRWXU|S_IRWXG|S_IRWXO)
%define S_IALLUGO	(S_ISUID|S_ISGID|S_ISVTX|S_IRWXUGO)
%define S_IRUGO		(S_IRUSR|S_IRGRP|S_IROTH)
%define S_IWUGO		(S_IWUSR|S_IWGRP|S_IWOTH)
%define S_IXUGO		(S_IXUSR|S_IXGRP|S_IXOTH)

%endif
%endif
;-
;-=========================================================================;
;- stat.h.inc <eof>
